
_main:

;PWM.c,24 :: 		void main() {
;PWM.c,26 :: 		INTCON = 0;    // Todas las interrupciones deshabilitadas
	CLRF       INTCON+0
;PWM.c,27 :: 		ANSEL = 0x04;   // Pin RA2 se configura como una entrada analgica
	MOVLW      4
	MOVWF      ANSEL+0
;PWM.c,28 :: 		ANSELH = 0;    // Los dems pines se configuran como digitales
	CLRF       ANSELH+0
;PWM.c,29 :: 		TRISA = 0x04;
	MOVLW      4
	MOVWF      TRISA+0
;PWM.c,30 :: 		TRISC = 0;     // Todos los pines del puerto PORTC se configuran como salida
	CLRF       TRISC+0
;PWM.c,31 :: 		PORTC = 0;     // Estado inicial del puerto PORTC
	CLRF       PORTC+0
;PWM.c,32 :: 		C1ON_bit = 0;    // se desactivan los comparadores analgicos
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;PWM.c,33 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;PWM.c,34 :: 		PWM1_Init(10000); // Inicializacin del mdulo PWM (10KHz)
	BCF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      99
	MOVWF      PR2+0
	CALL       _PWM1_Init+0
;PWM.c,35 :: 		Lcd_Init();                    // Inicializacin del visualizador LCD
	CALL       _Lcd_Init+0
;PWM.c,36 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);      // Comando LCD (apagar el cursor)
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;PWM.c,37 :: 		Lcd_Cmd(_LCD_CLEAR);           // Comando LCD (borrar el LCD)
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;PWM.c,38 :: 		text = "PWM_Controller";     // Definir el primer mensaje
	MOVLW      ?lstr1_PWM+0
	MOVWF      _text+0
;PWM.c,39 :: 		Lcd_Out(1,1,text);             // Escribir el primer mensaje en la primera lnea
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;PWM.c,40 :: 		text = "Cycle_Duty:";             // Definir el  segundo mensaje
	MOVLW      ?lstr2_PWM+0
	MOVWF      _text+0
;PWM.c,41 :: 		Lcd_Out(2,1,text);             // Definir el segundo mensaje
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      1
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _text+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;PWM.c,42 :: 		ADCON1 = 0x82;                 // Voltaje de referencia para la conversin A/D es VCC
	MOVLW      130
	MOVWF      ADCON1+0
;PWM.c,43 :: 		Delay_ms(2000);               // retardo para estabilizar
	MOVLW      11
	MOVWF      R11+0
	MOVLW      38
	MOVWF      R12+0
	MOVLW      93
	MOVWF      R13+0
L_main0:
	DECFSZ     R13+0, 1
	GOTO       L_main0
	DECFSZ     R12+0, 1
	GOTO       L_main0
	DECFSZ     R11+0, 1
	GOTO       L_main0
	NOP
	NOP
;PWM.c,44 :: 		PWM1_Start();                 // inicia el mdulo de PWM1
	CALL       _PWM1_Start+0
;PWM.c,46 :: 		while (1) {
L_main1:
;PWM.c,47 :: 		adc_rd = ADC_Read(2);        // Conversin A/D. Pin RA2 es la entrada analoga
	MOVLW      2
	MOVWF      FARG_ADC_Read_channel+0
	CALL       _ADC_Read+0
	MOVF       R0+0, 0
	MOVWF      _adc_rd+0
	MOVF       R0+1, 0
	MOVWF      _adc_rd+1
;PWM.c,48 :: 		Delay_ms(1);                // retardo para estabilizar
	MOVLW      2
	MOVWF      R12+0
	MOVLW      75
	MOVWF      R13+0
L_main3:
	DECFSZ     R13+0, 1
	GOTO       L_main3
	DECFSZ     R12+0, 1
	GOTO       L_main3
;PWM.c,49 :: 		tlong = (long)adc_rd * 255; // Convertir el resultado en centenas
	MOVF       _adc_rd+0, 0
	MOVWF      R0+0
	MOVF       _adc_rd+1, 0
	MOVWF      R0+1
	CLRF       R0+2
	CLRF       R0+3
	MOVLW      255
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Mul_32x32_U+0
	MOVF       R0+0, 0
	MOVWF      _tlong+0
	MOVF       R0+1, 0
	MOVWF      _tlong+1
	MOVF       R0+2, 0
	MOVWF      _tlong+2
	MOVF       R0+3, 0
	MOVWF      _tlong+3
;PWM.c,50 :: 		tlong = tlong / 1023;        // 0..1023 -> 0-1000
	MOVLW      255
	MOVWF      R4+0
	MOVLW      3
	MOVWF      R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R0+0, 0
	MOVWF      _tlong+0
	MOVF       R0+1, 0
	MOVWF      _tlong+1
	MOVF       R0+2, 0
	MOVWF      _tlong+2
	MOVF       R0+3, 0
	MOVWF      _tlong+3
;PWM.c,51 :: 		ch = tlong/100;
	MOVLW      100
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R0+0, 0
	MOVWF      _ch+0
;PWM.c,52 :: 		Lcd_Chr(2,12,48+ch);          // Escribir resultado en formato ASCII
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      12
	MOVWF      FARG_Lcd_Chr_column+0
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
;PWM.c,53 :: 		ch = (tlong / 10) % 10;      // Extraer decenas
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _tlong+0, 0
	MOVWF      R0+0
	MOVF       _tlong+1, 0
	MOVWF      R0+1
	MOVF       _tlong+2, 0
	MOVWF      R0+2
	MOVF       _tlong+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
	MOVF       R0+0, 0
	MOVWF      _ch+0
;PWM.c,54 :: 		Lcd_Chr_CP(48+ch);           // Escribir resultado en formato ASCII
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_CP_out_char+0
	CALL       _Lcd_Chr_CP+0
;PWM.c,55 :: 		ch = tlong % 10;             // Extraer unidades
	MOVLW      10
	MOVWF      R4+0
	CLRF       R4+1
	CLRF       R4+2
	CLRF       R4+3
	MOVF       _tlong+0, 0
	MOVWF      R0+0
	MOVF       _tlong+1, 0
	MOVWF      R0+1
	MOVF       _tlong+2, 0
	MOVWF      R0+2
	MOVF       _tlong+3, 0
	MOVWF      R0+3
	CALL       _Div_32x32_S+0
	MOVF       R8+0, 0
	MOVWF      R0+0
	MOVF       R8+1, 0
	MOVWF      R0+1
	MOVF       R8+2, 0
	MOVWF      R0+2
	MOVF       R8+3, 0
	MOVWF      R0+3
	MOVF       R0+0, 0
	MOVWF      _ch+0
;PWM.c,56 :: 		Lcd_Chr_CP(48+ch);           // Escribir resultado en formato ASCII
	MOVF       R0+0, 0
	ADDLW      48
	MOVWF      FARG_Lcd_Chr_CP_out_char+0
	CALL       _Lcd_Chr_CP+0
;PWM.c,57 :: 		division = adc_rd/4;        // reduce la resolucion del ADC a 8 bits
	MOVF       _adc_rd+0, 0
	MOVWF      R0+0
	MOVF       _adc_rd+1, 0
	MOVWF      R0+1
	RRF        R0+1, 1
	RRF        R0+0, 1
	BCF        R0+1, 7
	RRF        R0+1, 1
	RRF        R0+0, 1
	BCF        R0+1, 7
	MOVF       R0+0, 0
	MOVWF      _division+0
	MOVF       R0+1, 0
	MOVWF      _division+1
;PWM.c,58 :: 		PWM1_Set_Duty(division); //graba el valor de division en el PWM1
	MOVF       R0+0, 0
	MOVWF      FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;PWM.c,59 :: 		Delay_ms(850);
	MOVLW      5
	MOVWF      R11+0
	MOVLW      80
	MOVWF      R12+0
	MOVLW      224
	MOVWF      R13+0
L_main4:
	DECFSZ     R13+0, 1
	GOTO       L_main4
	DECFSZ     R12+0, 1
	GOTO       L_main4
	DECFSZ     R11+0, 1
	GOTO       L_main4
	NOP
;PWM.c,60 :: 		}
	GOTO       L_main1
;PWM.c,61 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
