
// PWM_ADC_LCD
// Conexiones del mdulo LCD
sbit LCD_RS at RD2_bit;
sbit LCD_EN at RD3_bit;
sbit LCD_D4 at RD4_bit;
sbit LCD_D5 at RD5_bit;
sbit LCD_D6 at RD6_bit;
sbit LCD_D7 at RD7_bit;
sbit LCD_RS_Direction at TRISD2_bit;
sbit LCD_EN_Direction at TRISD3_bit;
sbit LCD_D4_Direction at TRISD4_bit;
sbit LCD_D5_Direction at TRISD5_bit;
sbit LCD_D6_Direction at TRISD6_bit;
sbit LCD_D7_Direction at TRISD7_bit;
// Final de las conexiones del mdulo LCD
// Declarar variables
unsigned char ch;
unsigned int adc_rd;
unsigned int division;
char *text;
long tlong;

void main() {

  INTCON = 0;    // Todas las interrupciones deshabilitadas
  ANSEL = 0x04;   // Pin RA2 se configura como una entrada analgica
  ANSELH = 0;    // Los dems pines se configuran como digitales
  TRISA = 0x04;
  TRISC = 0;     // Todos los pines del puerto PORTC se configuran como salida
  PORTC = 0;     // Estado inicial del puerto PORTC
  C1ON_bit = 0;    // se desactivan los comparadores analgicos
  C2ON_bit = 0;
  PWM1_Init(10000); // Inicializacin del mdulo PWM (10KHz)
  Lcd_Init();                    // Inicializacin del visualizador LCD
  Lcd_Cmd(_LCD_CURSOR_OFF);      // Comando LCD (apagar el cursor)
  Lcd_Cmd(_LCD_CLEAR);           // Comando LCD (borrar el LCD)
  text = "PWM_Controller";     // Definir el primer mensaje
  Lcd_Out(1,1,text);             // Escribir el primer mensaje en la primera lnea
  text = "Cycle_Duty:";             // Definir el  segundo mensaje
  Lcd_Out(2,1,text);             // Definir el segundo mensaje
  ADCON1 = 0x82;                 // Voltaje de referencia para la conversin A/D es VCC
  Delay_ms(2000);               // retardo para estabilizar
  PWM1_Start();                 // inicia el mdulo de PWM1
  
  while (1) {
    adc_rd = ADC_Read(2);        // Conversin A/D. Pin RA2 es la entrada analoga
    Delay_ms(1);                // retardo para estabilizar
    tlong = (long)adc_rd * 255; // Convertir el resultado en centenas
    tlong = tlong / 1023;        // 0..1023 -> 0-1000
    ch = tlong/100;
    Lcd_Chr(2,12,48+ch);          // Escribir resultado en formato ASCII
    ch = (tlong / 10) % 10;      // Extraer decenas
    Lcd_Chr_CP(48+ch);           // Escribir resultado en formato ASCII
    ch = tlong % 10;             // Extraer unidades
    Lcd_Chr_CP(48+ch);           // Escribir resultado en formato ASCII
    division = adc_rd/4;        // reduce la resolucion del ADC a 8 bits
    PWM1_Set_Duty(division); //graba el valor de division en el PWM1
    Delay_ms(850);
  }
}